<meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
<link rel="stylesheet" href="style.css" type="text/css"/>
<script src="code.js" type="text/javascript"></script>

<h1>New empty_range and total_range predicates</h1>

<pre class="code">
  /*@ // before:
    predicate empty_range(struct Range range) =
      range.lob == range.upb + 1;
  */
</pre>

<pre class="code">
  /*@ // after:
    predicate empty_range(struct Range range) =
      range.lob > 0 && range.lob == range.upb + 1;

    predicate total_range(struct Range range) =
      range.lob == 0 && range.upb == UINT64_MAX;
  */
</pre>
